'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var builders = require('../ast/builders.cjs');
var guards = require('../guards.cjs');
var emitCall = require('../templates/emit-call.cjs');
var scope = require('../templates/scope.cjs');

// covers:
// $..test
// $..script


var deepSingleMember = (nodes, tree, ctx) => {
  if (
    nodes.length !== 1 ||
    !guards.isDeep(nodes[0]) ||
    !guards.isMemberExpression(nodes[0])
  ) {
    return false;
  }

  tree.push(
    builders.blockStatement([
      builders.ifStatement(
        builders.safeBinaryExpression(
          '!==',
          scope.default.property,
          builders.stringLiteral(nodes[0].value),
        ),
        builders.returnStatement(),
      ),
      emitCall.default(ctx.id, ctx.iterator.modifiers),
    ]),
    'tree-method',
  );

  tree.push(builders.stringLiteral(ctx.id), 'traverse');

  return true;
};

exports.default = deepSingleMember;
