'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var builders = require('../ast/builders.cjs');
var guards = require('../guards.cjs');
var emitCall = require('../templates/emit-call.cjs');
var scope = require('../templates/scope.cjs');

// Covers:
// $[*]
// $.*


const IS_NOT_ZERO_DEPTH_IF_STATEMENT = builders.ifStatement(
  builders.binaryExpression('!==', scope.default.depth, builders.numericLiteral(1)),
  builders.returnStatement(),
);

var topLevelWildcard = (nodes, tree, ctx) => {
  if (
    nodes.length !== 1 ||
    !guards.isWildcardExpression(nodes[0]) ||
    guards.isDeep(nodes[0])
  ) {
    return false;
  }

  tree.push(
    builders.blockStatement([
      IS_NOT_ZERO_DEPTH_IF_STATEMENT,
      emitCall.default(ctx.id, ctx.iterator.modifiers),
    ]),
    'tree-method',
  );

  tree.push(builders.stringLiteral(ctx.id), 'traverse');

  tree.traversalZones.create()?.resize().attach();

  return true;
};

exports.default = topLevelWildcard;
