'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var index = require('../codegen/baseline/index.cjs');
var index$1 = require('../runtime/index.cjs');
var parseExpressions = require('./utils/parse-expressions.cjs');

class Nimma {
  #compiledFn;
  #module;
  #sourceCode;

  constructor(expressions, { module = 'esm', customShorthands = null } = {}) {
    this.#compiledFn = null;
    this.#module = module;
    this.#sourceCode = null;

    this.tree = index.default(parseExpressions.default(expressions), {
      customShorthands,
      module,
    });
  }

  get sourceCode() {
    this.#sourceCode ??= String(this.tree.export(this.#module));
    return this.#sourceCode;
  }

  query(input, callbacks) {
    this.#compiledFn ??= Function(
      'module, require',
      `${String(this.tree.export('commonjs'))};return module.exports`,
    )({}, () => index$1);

    this.#compiledFn(input, callbacks);
  }

  static query(input, callbacks, options) {
    const nimma = new Nimma(Object.keys(callbacks), options);
    nimma.query(input, callbacks);
    return input => nimma.query(input, callbacks);
  }
}

exports.default = Nimma;
